#!/usr/bin/env python
"""
  see http://bit.ly/1i4ts55 re "Party Quiz program by SunCom"

  This script rips and writes to stdout the multiple choice and true/false
  questions from the five game disks. Output is tab separated but it should
  be trivial to modify for some other format - Elwix/Style
"""

# local import for CBMDisk
import cbmdisk

mc = []
tf = []

for filename in ['partyqu1.d64', 'partyqu2.d64', 'partyqu3.d64', 'partyqu4.d64', 'partyqu5.d64']:
    cbm_disk = cbmdisk.Disk(filename)
    # iterate over every block
    for track in xrange(1, 36):
        sector = 0
        while cbm_disk.is_sector_valid(track, sector):
            # ignore blocks with disk errors (ignore probably corrupt data)
            if cbm_disk.get_sector_error(track, sector) < 20:
                bytes = cbm_disk.get_sector_bytes(track, sector)
                chunks = bytes.split(chr(0x9b)+chr(0x9b))
                # this effectively skips the first few blocks of each disk that appear to contain superfluous non question text/data
                if len(chunks) == 5:
                    for question_chunk in chunks[:4]:
                        parts = question_chunk.split(chr(0x9b))
                        if len(parts) == 5:
                            mc.append((filename, track, sector, parts[0].replace(chr(0x00), ''), parts[1], parts[2], parts[3], parts[4]))
                        else:
                            tf.append((filename, track, sector, parts[0].replace(chr(0x00), ''), parts[1], parts[2] if len(parts) == 3 else None))
            sector += 1

for q in mc:
    print '{}\t{}\t{}\t{}\t{}\t{}\t{}\t{}\t'.format(q[0], q[1], q[2], q[3], q[4], q[5], q[6], q[7])

for q in tf:
    print '{}\t{}\t{}\t{}\t{}\t{}'.format(q[0], q[1], q[2], q[3], q[4], q[5])

exit(0)
